express = require('express');
app = express();
bodyParser = require('body-parser');
morgan = require('morgan');
mongoose = require('mongoose');
jwt = require('jsonwebtoken');
Dashboard = require('./Dashboard');
Payments = require('./Payment');
Users = require('./Users')
config = require('./config');

port = process.env.PORT || 8000;
mongoose.connect(config.database,{useNewUrlParser:true});

// application variables
app.set('superSecret', config.secret);
// config for body-parser
app.use(bodyParser.urlencoded({ extended: false}));
app.use(bodyParser.json());
// log request
app.use(morgan('combined'));
app.get('/', function(req, res) {
    res.send('wellcome to Student Management : The API is at http://localhost:' + port + '/admin');
  });






  //###############################USers And  Admin#####################
//check user and password
  app.post('/login', function(req, res) {
   
    Users.findOne({username: req.body.username}, function(err, user) {
      if (err) throw err;

      if (!user) {
        res.json({
          success: false,
          message: 'Authentication failed. User not found.'
        });
        return;
      }
      if (user.password != req.body.password) {
        res.json({
          success: false,
          message: 'Authentication failed. Wrong password.'
        });
        return;
      }
      res.json({
        success: true,
        username: user.username ,
        message: 'Authentication successfully finished.',
      });
    });
  });





//############################ User ##########################################


  UserRoutes = express.Router();

//####################### ดูข้อมูลส่วนตัว ##########################################


    // GET(http://localhost:8000/users/profile)
    UserRoutes.get('', function(req, res) {
      Users.findOne({id:req.query.id}, function(err, user) {
        if (err) throw err;
        if(!user){
          res.json({
            success: false,
            message: ' User not found.'
          });
          return;
        }

  
        res.json({name :user.username,
                  Email:user.Email,
                  Subject: user.sub_id
        });
      });
    }); 
  
      // GET(http://localhost:8000/users/profile/id)
      UserRoutes.get('/:id', function(req, res) {
        Users.findOne({id:req.params.id}, function(err, user) {
          if (err) throw err;
          if(!user){
            res.json({
              success: false,
              message: ' User not found.'
            });
            return;
          }
          res.json({name :user.username,
            Email:user.Email,
            Subject: user.sub_id
  });
        });
      });

  
      //########################## ดูยอดค้างชำระว่ามีหนี้ไหม #######################################
 // GET(http://localhost:8000/users/due)
 UserRoutes.post('/due', function(req, res) {
  Payments.findOne({id:req.query.id}, function(err, user) {
    if (err) throw err;
    if(!user){
      res.json({
        success: true,
        message: 'WOW!!!! you not debt.'
      });
      return;
    }
    res.json(user);
  });
});


  // GET(http://localhost:8000/users/due/:id)
  UserRoutes.post('/due/:id', function(req, res) {
    Payments.findOne({id:req.params.id}, function(err, user) {
      if (err) throw err;
      if(!user){
        res.json({
          success: true,
          message: 'WOW!!!! you not debt.'
        });
        return;
      }
      res.json(user);
    });
  });






  //############################# Admin ################################################
  
  apiRoutes = express.Router();
  // GET(http://localhost:8000/admin/)
apiRoutes.get('/', function(req, res) {
  res.json({ message: 'Welcome to API routing for Admin'});
});


//#############เพิ่มนักเรียนเข้าไป#################################

 // POST(http://localhost:8000/admin/edituser/addition)  
  apiRoutes.post('/students/addition', function(req, res) {
    let query ;
    demo = new Users({
      id:req.body.id,
      username: req.body.username,
      password: req.body.password,
      Email:    req.body.Email,
      payment:  req.body.payment,
      sub_id:   req.body.subject  
    });
    query=demo;
    payment = new Payments({ 
      id:req.body.id,
      username: req.body.username,
      payment:  req.body.payment,
      sub_id:   req.body.subject
    });

   // เพ่ิมเข้าเกี่ยวหนี้
    Dashboard.findOne({id:0}, function(err, user) {
      if (err) throw err;
     

          user.due +=parseInt(req.body.payment,10);
                
        
       // บันทึกค้างชำระเข้าไป
        user.save(function(err,update){
          if(err) {throw err;
          }
  
        });
            
    });

  // เพิ่มผู้ใช้งาน
    demo.save(function(err) {
      if (err) throw err
      
    console.log('save data complete')
   
    });
    //เพิ่มเข้าไปในส่วนของ คนที่ยังไม่ชำระเงิน
   payment.save(function(err) {
      if (err) throw err
    res.json({success:true,addition:query});
    });

  });

  
//#############    ลบนักเรียน  #################################
 // POST(http://localhost:8000/admin/edituser/addition)

  
//delete with id ลบผู้ใช้งาน
apiRoutes.delete('/students/deletion', function(req, res){
  let query = {id:req.query.id}

  Users.remove(query,function(err){
    if(err){
      console.log(err);
    }
   
  });

  Payments.remove(query,function(err){
    if(err){
      console.log(err);
    }
    
  });
  
  res.json({success:'deleted success !'});
     
});


//############# แก้ไขนักเรียน #################################
 // POST(http://localhost:8000/admin/edituser/addition)

 apiRoutes.put('/students/modification', function(req, res) {
   //แก้ไขในส่วนของผู้ใช้งาน
  Users.findOne({id:req.body.id}, function(err, user) {
    if (err) throw err;
    
    if (!user) {
      res.json({
        success: false,
        message: ' User not found.'
      });
      return;
    }else {
      if (req.body.username) {
        user.username = req.body.username;
              
      }
      if (req.body.password) {
        user.password = req.body.password;
              
      }
      if (req.body.Email) {
        user.Email = req.body.Email;
             
      }
      if (req.body.payment) {
        user.payment = req.body.payment;
              
      }
      if (req.body.subject) {
        user.sub_id = req.body.subject;
              
      }
      user.save(function(err,update){
        if(err) {throw err;
        }

      });
    }

  });

//แก้ไขในส่วนของคนค้างชำระหากยังค้างชำระ
  Payments.findOne({id:req.body.id}, function(err, user) {
    if (err) throw err;
  
    if (!user) {
      res.json({
        success: true,
        message: 'Update successfully finished.',
      });
    }else {
      if (req.body.username) {
        user.username = req.body.username;
              
      }
      if (req.body.payment) {
        user.payment = req.body.payment;
              
      }
      if (req.body.subject) {
        user.sub_id = req.body.subject;
              
      }
      user.save(function(err,update){
        if(err) {throw err;
        }else{
          res.json({
            success: true,
            now: update ,
            message: 'Update successfully finished.',
          });


        }

      });
    }

    
  });

  
});

//######################### ลบผู้ใช้งาน ################################

//delete with id
apiRoutes.delete('/students/deletion/:id', function(req, res){
  let query = {id:req.params.id}

  Users.remove(query,function(err){
    if(err){
      console.log(err);
    }
  });
  Payments.remove(query,function(err){
    if(err){
      console.log(err);
    }
    res.json({success:'deleted success !'});
  });
  
     
     
});


//########################## ดูข้อมูลผู้ใช้งานทั้งหมด #######################################


    // GET(http://localhost:8000/admin/students)
  apiRoutes.get('/students', function(req, res) {
    Users.find({}, function(err, user) {
      if (err) throw err;

      res.json(user);
    });
  });
  //######################### ดูข้อมูลผู้ใช้งาน ตามไอดี ########################################


    // GET(http://localhost:8000/admin/students/)
    apiRoutes.post('/students/:id', function(req, res) {
      Users.findOne({id:req.params.id}, function(err, user) {
        if (err) throw err;
  
        res.json(user);
      });
    });
    apiRoutes.post('/students', function(req, res) {
      Users.findOne({id:req.query.id}, function(err, user) {
        if (err) throw err;
  
        res.json(user);
      });
    });
    //########################### ดูรายชื่อทั้งหมด ######################################


    // GET(http://localhost:8000/admin/listuser/exhibit)
    apiRoutes.get('/students/names', function(req, res) {
      Users.find({}, function(err, user) {
        if (err) throw err;
        var str = [];
       user.forEach(function(queryname){
         str.push({name : queryname.username})
         
       });
       res.contentType('application/json');
       res.send(JSON.stringify(str));
        

        
      });
      
    });
    //################### แสดง รายได้รวม และ ยอดหนี้ค้างชำระ ###############

    apiRoutes.get('/revenue', function(req, res) {
      Dashboard.findOne({id:0}, function(err, user) {
        if (err) throw err;
  
        res.json(user);
      });
    });
    //################### คนที่ค้างชำระเงิน ###############

    apiRoutes.get('/payment/list', function(req, res) {
      Payments.find({}, function(err, user) {
        if (err) throw err;
  
        res.json(user);
      });
    });

    //################### ชำระเงิน ###############

    apiRoutes.put('/payment', function(req, res) {
      Users.findOne({id:req.body.id}, function(err, user) {
        if (err) throw err;
        
        if (!user) {
          res.json({
            success: false,
            message: ' User not found.'
          });
          return;
        }else {
         
          if (req.body.payment) {
            user.payment = user.payment-req.body.payment;
            if(user.payment<=0){user.payment=0;}
                  
          }        
          user.save(function(err,update){
            if(err) {throw err;
            }
    
          });
        }   
        
      });

      Dashboard.findOne({id:0}, function(err, user) {
        if (err) throw err;
  
            user.due -=parseInt(req.body.payment,10);
            user.income +=parseInt(req.body.payment,10);           
          
        
          user.save(function(err,update){
            if(err) {throw err;
            }
    
          });
              
      });
    
    
      Payments.findOne({id:req.body.id}, function(err, user) {
        let query = {id:req.body.id}
        var check = false ;
        if (err) throw err;
        
        if (!user) {
          res.json({
            success: false,
            message: ' User not found.'
          });
          return;
        }else {
          if (req.body.payment) {
            user.payment = user.payment-req.body.payment;
            if(user.payment<=0){check=true;}
          }
            
          }
         if(check){
          Payments.remove(query,function(err){
            if(err){
              console.log(err);
            }
            res.json({success:' No debt success !'});
          });

         }else {
          user.save(function(err,update){
            if(err) {throw err;
            }else{
              res.json({
                success: true,
                now: update ,
                message: 'Update successfully finished.Still has outstanding balance.',
              });   
    
            }    
          });
        }
          
        
      });
    });
    







app.use('/users',UserRoutes);
 app.use('/admin', apiRoutes);
app.listen(port);
console.log('started http://localhost:' + port + '/');
